# Contributing to shmdata documentation

Thank you for considering contributing to the shmdata documentation!

## Code of Conduct

First, please read our Code of Conduct for the documentation project: [link to the Code of Conduct]. This Code applies to the project in general, including but not limited to GitLab issues, code and text contributions and communications related to the project.

## Disclaimer

Right now, the shmdata documentation project is at an early stage of development. At this experimental phase we will be making a lot of changes to the structure of this repository and tooling. Contributing as a non-core developer at this time, may involve more work than at a later stage.

## How to make a proposal 

That being said, if you wish to contribute, the best way is to get in touch through opening a GitLab issue describing the work you wish to do. State what you are planning to work on, and look for feedback on this issue. We will read and comment the proposal - our goal is to accept as many contributions as possible, but we want to ensure a smooth integration.

There are a few items we are always looking forward to reading, including tutorials on features we have yet to cover or how-to guides detailing steps to accomplish specific tasks. 

The `ROADMAP.md` file describes the current accepted enhancements for the project. They are usually considered working tickets for the core community. If you wish to contribute on one of these items, please let us know through commenting on the corresponding GitLab issue.

## How to install the documentation on your workstation

### Getting started with Sphinx

see the sphinx workshop

### Get in touch !

### Choosing what to work on

### Working on an issue


#### Opening an issue

### Setting up the development environment


#### Clone the git repo

	git clone git@gitlab.com:sat-metalab/documentations/shmdata.git shmdata-docs
	
#### Requirements

Check the requirements.txt file for a list of requirements.

You should install them in a virtual environment.

First start by creating a virtual environment:

    cd shmdata-docs
    python3 -m virtualenv venv
	
On Ubuntu, you can activate the environment with:

	source venv/bin/activate

You can then install the requirements with:

        pip install wheel
        pip install -r requirements.txt

#### Create a new branch

	git checkout -b feature/BRANCH-NAME
	
When making a change to the docs, you will need to first start by making the change in the original `.rst` files, in English.

### Making a change to the original file

In one of the `.rst` file located in the `source` folder, make the needed changes.

### Translate the changes to French

Afterwards, you may proceed to translating the changes to French. Please read the `CONVENTIONS` doc for translation conventions for this project. 

#### Setup `sphinx-intl`

In your virtualenv, install `sphinx-intl` :

    pip install sphinx-intl
    
Add the changes you made to the `.po` files used for translation:

    make intl
    
In `source/locale`, you should see a `fr` folder. This folder has the same structure as the `source` folder. 

Open the `.po` file with the same name as the `.rst` file you made changes to. Translate the changes.

## Review your changes

To review your changes, build the project locally and deploy on localhost.

### Build the project locally

To build the project locally, run:

    make htmllocaltest

Your HTML files are now in the `public` folder! :star:

### Deploy on localhost

Run the following command to create a local server:

	python3 -m http.server

In a web browser, navigate to `0.0.0.0:8000/public`. You should be able to view the HTML files that were generated by Sphinx.

## Commit your changes

## Push your changes

## Make an MR

